import { switchMap } from './switchMap';
import { operate } from '../util/lift';
import { createOperatorSubscriber } from './OperatorSubscriber';
export function switchScan(accumulator, seed) {
    return operate((source, subscriber) => {
        let state = seed;
        switchMap((value, index) => accumulator(state, value, index))(source).subscribe(createOperatorSubscriber(subscriber, (innerValue) => {
            state = innerValue;
            subscriber.next(innerValue);
        }));
        return () => {
            state = null;
        };
    });
}
//# sourceMappingURL=switchScan.js.map