import { EMPTY } from '../observable/empty';
import { operate } from '../util/lift';
import { createOperatorSubscriber } from './OperatorSubscriber';
export function takeLast(count) {
    return count <= 0
        ? () => EMPTY
        : operate((source, subscriber) => {
            let ring = new Array(count);
            let counter = 0;
            source.subscribe(createOperatorSubscriber(subscriber, (value) => {
                ring[counter++ % count] = value;
            }, () => {
                const start = count <= counter ? counter : 0;
                const total = Math.min(count, counter);
                for (let n = 0; n < total; n++) {
                    subscriber.next(ring[(start + n) % count]);
                }
                subscriber.complete();
            }, undefined, () => {
                ring = null;
            }));
        });
}
//# sourceMappingURL=takeLast.js.map