import { operate } from '../util/lift';
import { createOperatorSubscriber } from './OperatorSubscriber';
export function takeWhile(predicate, inclusive = false) {
    return operate((source, subscriber) => {
        let index = 0;
        const operatorSubscriber = createOperatorSubscriber(subscriber, (value) => {
            if (predicate(value, index++)) {
                subscriber.next(value);
            }
            else {
                operatorSubscriber.unsubscribe();
                if (inclusive) {
                    subscriber.next(value);
                }
                subscriber.complete();
            }
        });
        source.subscribe(operatorSubscriber);
    });
}
//# sourceMappingURL=takeWhile.js.map